from kit_up.core.clauses import exceptions as cl_excs
from kit_up.core import exceptions as excs


class BaseRepositoryExc(excs.BaseKitUpException):
    pass


class EntityNotFoundExc(BaseRepositoryExc):
    pass


class EntityConflictExc(BaseRepositoryExc):
    pass


class PluralResultExc(BaseRepositoryExc):
    pass


class ClauseRepositoryExc(BaseRepositoryExc, cl_excs.BaseClauseExc):
    pass


class UnknownClauseField(ClauseRepositoryExc, cl_excs.UnknownClauseField):
    pass


class UnsupportedClauseOperation(ClauseRepositoryExc, cl_excs.UnsupportedClauseOperation):
    pass


class UnprocessableClause(ClauseRepositoryExc, cl_excs.UnprocessableClause):
    pass
